package de.his.UNOPdfExport;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import com.sun.star.text.XTextDocument;

import de.his.core.util.openoffice.OOoConnection;
import de.his.core.util.openoffice.OOoHelper;

public class ZIndexMergeTest {

    private String TEST_FILE_URL = "test.odt";

    private int REPEAT_COUNT = 3;

    public static void main(String[] args) {

        ZIndexMergeTest zIndexMergeTest = new ZIndexMergeTest();
        zIndexMergeTest.doWork();

        System.out.println("The End...");
        System.exit(0);
    }

    private void doWork() {
        List<File> fileSet = new ArrayList<File>();
        OOoConnection conn = null;
        OOoHelper oh = new OOoHelper();

        try {
            conn = oh.getConnection();
        } catch (Exception e) {

            // ooooh... fail...
            System.out.println(e.getMessage());
            System.exit(1);
        }

        String url = getPathToFile() + TEST_FILE_URL;
        System.out.println(url);
        XTextDocument template = OOoHelper.loadTextDocument(conn.getComponentLoader(), OOoHelper.PROTOCOL_FILE, url, true);

        for (int i = 1; i <= REPEAT_COUNT; i++) {

            File tempFilePdf = OOoHelper.storeAsTemp(template, "template_" + i + "_", "odt", Long.valueOf(0));
            fileSet.add(tempFilePdf);
            try {
                //System.out.println("Stored file under: " + tempFilePdf.getCanonicalPath());
            } catch (Exception e) {
                // nothing
                System.exit(1);
            }

        }

        try {
            File tempResultFile = oh.mergeOdtSet(fileSet, "odt", "test");
            System.out.println("Stored merged odt file under: " + tempResultFile.getCanonicalPath());
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            System.exit(1);
        } finally {
            for (int i = 0; i < REPEAT_COUNT; i++) {
                File file = fileSet.get(i);
                file.delete();
            }
        }


        oh.close();


    }

    private String getPathToFile() {
        File file = new File(".");
        String path = "";
        try {
            path = file.getCanonicalPath();
        } catch (Exception e) {
            // nothing
            System.exit(1);
        }

        System.out.println(path);
        return path + "/";
    }



}
